"use strict";

/* Alpine - Copyright (c) 2009-2021 StarTex Software, LLC */

var AdminCore = AdminCore || {};

AdminCore.InstanceMoveDatabaseModel = function (instanceMoveData) {
    var self = this;

    self.IsLoading = ko.observable(true);

    self.HasError = ko.observable(null);
    self.ErrorMessage = ko.observable(null);

    self.Databases = ko.observableArray(instanceMoveData.Databases);

    self.FromDatabase = ko.observable(null);
    self.ToDatabase = ko.observable(null);



    self.Init = function () {

        self.IsLoading(false);

    }();

    self.Save_Click = function () {

        self.IsLoading(true);

        self.HasError(false);
        self.ErrorMessage(null);

        var postData = {
            FromContentDatabaseUID: self.FromDatabase().RowUID,
            ToContentDatabaseUID: self.ToDatabase().RowUID
        };

        CommonCore.PostData('/admin/instancemove/database/save', ko.toJSON(postData), function (data) {
            //  success
            var o = CommonCore.ParseJson(data);

            if (o.ResultCode == 'OK') {
                //  move was scheduled so lets go back to the instances page which now displays the instance that is being moved
                window.location = '/admin/instancemove';

            } else {
                //  server returned an error
                self.HasError(true);
                self.ErrorMessage(o.Description);
                self.IsLoading(false);
            }

        }, function (error) {
            self.HasError(true);
            self.ErrorMessage(error);
            self.IsLoading(false);

        }, 60 * 1000);
    };

};