﻿"use strict";

/* Alpine - Copyright (c) 2009-2021 StarTex Software, LLC */

var AdminCore = AdminCore || {};

AdminCore.PackageEditModel = function (provisionPackage, databases) {
    var self = this;

    self.HasError = ko.observable(null);
    self.ErrorMessage = ko.observable(null);

    self.Databases = ko.observableArray(databases);
    self.CurrentPackage = ko.observable(null);
    self.Title = ko.observable(null);

    self.Themes = ko.observableArray(AdminCore.Shared.ThemeList);


    self.CurrentPackage = ko.observable(null);

    self.Init = function() {

        self.CurrentPackage(new AdminCore.ProvisionPackage(self.Databases()));

        if (CommonCore.IsNullOrEmpty(provisionPackage.RowUID)) {
            // Add Package
            self.Title('Add Package');
            self.CurrentPackage().RowUID(CommonCore.GenerateUID());
        } else {
            // Edit Package
            self.Title('Edit Package');
            self.CurrentPackage().LoadFromJson(provisionPackage);
        }
    }(); // Init

    self.InstanceTypes = [ 'DEV', 'TEST', 'QA', 'DEMO', 'TRIAL', 'RAIN', 'TEMP', 'STAGE', 'PILOT', 'SANDBOX', 'PROD'];

    self.AfterSaveAtempt = ko.observable(false);

    self.SavePackage = function() {
        if (self.CurrentPackage().IsValid()) {
            CommonCore.PostData('/admin/package/save', ko.toJSON(self.CurrentPackage().SaveToJson()), function(data) {
                var o = CommonCore.ParseJson(data);
                if (o.ResultCode == "OK") {
                    location.href = "/admin/packages";
                } else {
                    self.HasError(true);
                    self.ErrorMessage(o.Description + " - " + o.Details);
                }
            }, function(err) {
                // error adding package
                self.HasError(true);
                self.ErrorMessage(err);
            });
        } else {
            // Invalid Package
            self.AfterSaveAtempt(true);
        }
    }
};