﻿"use strict";

/* Alpine - Copyright (c) 2009-2021 StarTex Software, LLC */

var AdminCore = AdminCore || {};

AdminCore.UserListModel = function (usersJson) {
    var self = this;

    self.IsLoading = ko.observable(true);

    self.UsersJson = ko.mapping.fromJS(usersJson);

    for (var i = 0, row; row = self.UsersJson()[i]; i++) {
        row.IsDeleted = ko.observable(false);
    }

    self.IsLoading(false);


    self.DeleteUser = function (row) {

        var user = ko.mapping.toJS(row);

        CommonCore.DownloadData('users/delete/' + user.RowUID, function (data) {

            var o = $.parseJSON(data);
            if (o.ResultCode == 'OK') {
                row.IsDeleted(true);
            } else if (o.ResultCode == "Validation") {
                alert(o.Description);
            } else {
                alert(o.Description + ' - ' + o.Details);
            }
        }, function (message) {

            // error
            alert('Error deleting  - ' + message);

        });
    };   

    

};